<?php

namespace Drupal\landingpage\Plugin\Field\FieldWidget;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\WidgetBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Plugin implementation of the 'landing_page_theme_widget' widget.
 *
 * @FieldWidget(
 *   id = "landing_page_theme_widget",
 *   label = @Translation("LandingPage Theme widget"),
 *   field_types = {
 *     "landing_page_theme_field_type"
 *   }
 * )
 */
class LandingPageThemeWidget extends WidgetBase {

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {

    $value = isset($items[$delta]->value) ? $items[$delta]->value : '';

    $options = array();
    $theme_handler = \Drupal::service('theme_handler');
    $themes = $theme_handler->listInfo();
    foreach ($themes as $key => $theme) {
      $options[$key] = $theme_handler->getName($key);
    }

    $element = array(
      '#type' => 'select',
      '#title' => t('Theme'),
      '#options' => $options,
      '#default_value' => $value,
      '#multiple' => FALSE,
    );

    return array('value' => $element);
  }

}
